import { ResourceItem } from "./types/ResourceItem";

type simple = string | number | boolean;

type cbParams = (params: Params) => simple;

interface Router {
  [name: string]: string[]
}

interface Params {
  [name: string]: simple | cbParams;
}

interface Options {
  route?: string;
  baseUrl?: string;
}

export default Ngw
export class Ngw {
  options: Options;
  constructor(options: Options);
  connect(callback: (router: Router) => void, context: any): void;
  request<K extends keyof RequestItemsParamsMap>(
    name: K,
    callback: (data: RequestItemsResponseMap[K]) => void,
    params: RequestItemsParamsMap[K],
    error?: Error,
    context?: any): void;
  makeQuery(
    url: string,
    callback: ({}) => void,
    params: Params,
    context: any,
    error: Error): void;

  private route?: Router;

}

export {
  ResourceItem
}

interface RequestItemsResponseMap {
  'resource.item': ResourceItem;
  'resource.child': any;
  [x: string]: {[x: string]: any};
}

// This part of the code is automatically generated by
// ==./scripts/generator.js==
interface RequestItemsParamsMap {
  'pyramid.settings': null;
  'feature_layer.store.item': { id: number, feature_id: number };
  'feature_layer.feature.update': { id: number, feature_id: number };
  'feature_layer.feature.collection': { id: number };
  'feature_layer.feature.show': { id: number, feature_id: number };
  'file_upload.upload': null;
  'pyramid.home_path': null;
  'resource.tree': { id: number };
  'webmap.display.tiny': { id: number };
  'feature_layer.identify': null;
  'render.tile': null;
  'auth.user.edit': { id: number };
  'resource.widget': null;
  'resource.child': { id: number, child_id: number };
  'auth.user.delete': { id: number };
  'auth.user.item': { id: number };
  'resource.update': { id: number };
  'layer.extent': { id: number };
  'resource.delete': { id: number };
  'pyramid.system_name': null;
  'resource.quota': null;
  'auth.group.delete': { id: number };
  'webmap.display': { id: number };
  'qgis.vector_style_qml': { id: number };
  'resource.create': { id: number };
  'auth.user.create': null;
  'render.image': null;
  'resource.store': { id: number };
  'resource.show': { id: number };
  'feature_attachment.image': { id: number, fid: number, aid: number };
  'mapserver.qml_transform': null;
  'feature_attachment.item': { id: number, fid: number, aid: number };
  'resource.item': { id: number };
  'feature_attachment.download': { id: number, fid: number, aid: number };
  'auth.group.edit': { id: number };
  'resource.permission': { id: number };
  'pyramid.cors': null;
  'resource.schema': null;
  'feature_layer.feature.browse': { id: number };
  'wfsserver.wfs': { id: number };
  'auth.group.item': { id: number };
  'pyramid.custom_css': null;
  'pyramid.miscellaneous': null;
  'pyramid.route': null;
  'feature_attachment.collection': { id: number, fid: number };
  'auth.register': null;
  'feature_layer.store': { id: number };
  'auth.group.create': null;
  'resource.json': { id: number };
  'pyramid.locdata': { component: number, locale: number };
  'feature_layer.feature.count': { id: number };
  'auth.user.collection': null;
  'wmsserver.wms': { id: number };
  'resource.collection': null;
  'feature_layer.geojson': { id: number };
  'feature_layer.csv': { id: number };
  'feature_layer.field': { id: number };
  'auth.group.collection': null;
  'pyramid.statistics': null;
  'auth.current_user': null;
  'feature_layer.feature.item': { id: number, fid: number };
  'pyramid.pkg_version': null;
}
